Index: cpukit/libdl/rtl-mdreloc-moxie.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-moxie.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-moxie.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -68,5 +68,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -82,8 +82,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
+  return rtems_rtl_elf_rel_no_error;
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -123,5 +123,5 @@
       if (((Elf32_Sword)tmp > 0x1ff) || ((Elf32_Sword)tmp < -(Elf32_Sword)0x200)){
         printf("Overflow for PCREL10: %ld exceed -0x200:0x1ff\n", tmp);
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -137,11 +137,11 @@
       rtems_rtl_set_error (EINVAL, "rela type record not supported");
       printf("Unsupported reloc types\n");
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
+  return rtems_rtl_elf_rel_no_error;
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -158,8 +158,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -176,5 +176,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-powerpc.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-powerpc.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-powerpc.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -214,5 +214,12 @@
 }
 
-static bool
+/**
+ * The offsets in the reloc words.
+ */
+#define REL_R_OFFSET (0)
+#define REL_R_INFO   (1)
+#define REL_R_ADDEND (2)
+
+static rtems_rtl_elf_rel_status
 rtems_rtl_elf_reloc_rela (rtems_rtl_obj*            obj,
                           const Elf_Rela*           rela,
@@ -227,4 +234,5 @@
   uint32_t mask = 0;
   uint32_t bits = 0;
+  bool     needs_tramp = false;
 
   where = (Elf_Addr *)(sect->base + rela->r_offset);
@@ -260,4 +268,11 @@
         mask = 0x3fffffc;
       }
+
+      if (parsing && sect->base == 0) {
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: ADDR14/ADDR24 tramp cache\n");
+        return rtems_rtl_elf_rel_tramp_cache;
+      }
+
       tmp = (symvalue + rela->r_addend) >> 2;
       if (tmp > ((1<<bits) - 1 )) {
@@ -265,7 +280,15 @@
         size_t   tramp_size = get_veneer_size(ELF_R_TYPE(rela->r_info));
         if (parsing) {
-          obj->tramp_size += tramp_size;
-          return true;
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: ADDR14/ADDR24 tramp add\n");
+          return rtems_rtl_elf_rel_tramp_add;
         }
+        if (!rtems_rtl_obj_has_tramp_space (obj, tramp_size)) {
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: ADDR14/ADDR24 no tramp slot: %s\n", rtems_rtl_obj_oname (obj));
+          rtems_rtl_set_error (ENOMEM, "%s: tramp: no slot: ADDR14/ADDR24", sect->name);
+          return rtems_rtl_elf_rel_failure;
+        }
+        needs_tramp = true;
         tramp_addr = (Elf_Addr) obj->tramp_brk;
         obj->tramp_brk = set_veneer(obj->tramp_brk,
@@ -284,5 +307,6 @@
         *where = tmp;
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-          printf ("rtl: ADDR14/ADDR24 %p @ %p in %s\n",
+          printf ("rtl: ADDR14/ADDR24%s %p @ %p in %s\n",
+                  needs_tramp ? "(tramp)" : "",
                   (void *)*where, where, rtems_rtl_obj_oname (obj));
       }
@@ -340,4 +364,10 @@
         mask = 0xfffc;
         bits = 14;
+      }
+
+      if (parsing && sect->base == 0) {
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+          printf ("rtl: REL24/REL14 tramp cache\n");
+        return rtems_rtl_elf_rel_tramp_cache;
       }
 
@@ -348,7 +378,15 @@
         size_t   tramp_size = get_veneer_size(ELF_R_TYPE(rela->r_info));
         if (parsing) {
-          obj->tramp_size += tramp_size;
-          return true;
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: REL24/REL14 tramp add\n");
+          return rtems_rtl_elf_rel_tramp_add;
         }
+        if (!rtems_rtl_obj_has_tramp_space (obj, tramp_size)) {
+          if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
+            printf ("rtl: REL24/REL14 no tramp slot: %s\n", rtems_rtl_obj_oname (obj));
+          rtems_rtl_set_error (ENOMEM, "%s: tramp: no slot: REL24/REL14", sect->name);
+          return rtems_rtl_elf_rel_failure;
+        }
+        needs_tramp = true;
         tramp_addr = (Elf_Addr) obj->tramp_brk;
         obj->tramp_brk = set_veneer(obj->tramp_brk,
@@ -368,5 +406,6 @@
         *where = tmp;
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
-          printf ("rtl: REL24/REL14 %p @ %p in %s\n",
+          printf ("rtl: REL24/REL14%s %p @ %p in %s\n",
+                  needs_tramp ? "(tramp)" : "",
                   (void *)*where, where, rtems_rtl_obj_oname (obj));
       }
@@ -413,10 +452,10 @@
                            "in non-PLT relocations",
                            sect->name, (uint32_t) ELF_R_TYPE(rela->r_info));
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -435,5 +474,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -452,5 +491,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -467,8 +506,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -485,5 +524,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-sparc.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-sparc.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-sparc.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -186,5 +186,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -200,8 +200,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -219,13 +219,13 @@
   type = ELF_R_TYPE(rela->r_info);
   if (type == R_TYPE(NONE))
-    return true;
+    return rtems_rtl_elf_rel_no_error;
 
   /* We do JMP_SLOTs in _rtld_bind() below */
   if (type == R_TYPE(JMP_SLOT))
-    return true;
+    return rtems_rtl_elf_rel_no_error;
 
   /* COPY relocs are also handled elsewhere */
   if (type == R_TYPE(COPY))
-    return true;
+    return rtems_rtl_elf_rel_no_error;
 
   /*
@@ -234,5 +234,5 @@
    */
   if (type > R_TYPE(6))
-    return false;
+    return rtems_rtl_elf_rel_failure;
 
   value = rela->r_addend;
@@ -246,5 +246,5 @@
       printf ("rtl: reloc relative in %s --> %p",
               rtems_rtl_obj_oname (obj), (void *)*where);
-    return true;
+    return rtems_rtl_elf_rel_no_error;
   }
 
@@ -316,8 +316,8 @@
             (void *)tmp, where, rtems_rtl_obj_oname (obj));
 
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -334,8 +334,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -352,5 +352,5 @@
   (void) symvalue;
   printf ("rtl: rel type record not supported; please report\n");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-mdreloc-v850.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-v850.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-mdreloc-v850.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -68,5 +68,5 @@
 }
 
-bool
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela_tramp (rtems_rtl_obj*            obj,
                                    const Elf_Rela*           rela,
@@ -82,8 +82,8 @@
   (void) syminfo;
   (void) symvalue;
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rela (rtems_rtl_obj*            obj,
                              const Elf_Rela*           rela,
@@ -126,5 +126,5 @@
       if (((Elf_Sword)tmp > 0x1fffff) || ((Elf_Sword)tmp < -0x200000)) {
         printf("Overflow\n");
-        return false;
+        return rtems_rtl_elf_rel_failure;
       }
 
@@ -146,11 +146,11 @@
       rtems_rtl_set_error (EINVAL, "rela type record not supported");
       printf("error reloc type\n");
-      return false;
+      return rtems_rtl_elf_rel_failure;
   }
 
-  return true;
-}
-
-bool
+  return rtems_rtl_elf_rel_no_error;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel_tramp (rtems_rtl_obj*            obj,
                                   const Elf_Rel*            rel,
@@ -167,8 +167,8 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
-}
-
-bool
+  return rtems_rtl_elf_rel_failure;
+}
+
+rtems_rtl_elf_rel_status
 rtems_rtl_elf_relocate_rel (rtems_rtl_obj*            obj,
                             const Elf_Rel*            rel,
@@ -185,5 +185,5 @@
   (void) symvalue;
   rtems_rtl_set_error (EINVAL, "rel type record not supported");
-  return false;
+  return rtems_rtl_elf_rel_failure;
 }
 
Index: cpukit/libdl/rtl-obj.c
===================================================================
--- cpukit/libdl/rtl-obj.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-obj.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -584,8 +584,8 @@
 rtems_rtl_obj_alloc_trampoline (rtems_rtl_obj* obj)
 {
-  if (obj->tramp_size == 0)
+  if (obj->tramps_size == 0)
     return true;
   obj->trampoline = rtems_rtl_alloc_new (RTEMS_RTL_ALLOC_OBJECT,
-                                         obj->tramp_size,
+                                         obj->tramps_size,
                                          true);
   if (obj->trampoline == NULL)
@@ -904,5 +904,5 @@
   {
     rtems_cache_instruction_sync_after_code_change(obj->trampoline,
-                                                   obj->tramp_size);
+                                                   obj->tramps_size);
   }
 }
@@ -999,4 +999,158 @@
 }
 
+static void
+rtems_rtl_obj_sections_locate (uint32_t            mask,
+                               rtems_rtl_alloc_tag tag,
+                               rtems_rtl_obj*      obj,
+                               uint8_t*            base)
+{
+  rtems_chain_control* sections = &obj->sections;
+  rtems_chain_node*    node = rtems_chain_first (sections);
+  size_t               base_offset = 0;
+  int                  order = 0;
+
+  if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
+    printf ("rtl: locating section: mask:%08" PRIx32 " base:%p\n", mask, base);
+
+  while (!rtems_chain_is_tail (sections, node))
+  {
+    rtems_rtl_obj_sect* sect = (rtems_rtl_obj_sect*) node;
+
+    if ((sect->size != 0) && ((sect->flags & mask) == mask))
+    {
+      if (sect->load_order == order)
+      {
+        if ((sect->flags & RTEMS_RTL_OBJ_SECT_ARCH_ALLOC) == 0)
+        {
+          base_offset = rtems_rtl_obj_align (base_offset, sect->alignment);
+          sect->base = base + base_offset;
+        }
+
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
+          printf ("rtl: locating:%2d: %s -> %p (s:%zi f:%04" PRIx32
+                  " a:%" PRIu32 " l:%02d)\n",
+                  order, sect->name, sect->base, sect->size,
+                  sect->flags, sect->alignment, sect->link);
+
+        if (sect->base)
+          base_offset += sect->size;
+
+        ++order;
+
+        node = rtems_chain_first (sections);
+        continue;
+      }
+    }
+
+    node = rtems_chain_next (node);
+  }
+}
+
+bool
+rtems_rtl_obj_alloc_sections (rtems_rtl_obj*             obj,
+                              int                        fd,
+                              rtems_rtl_obj_sect_handler handler,
+                              void*                      data)
+{
+  size_t text_size;
+  size_t const_size;
+  size_t eh_size;
+  size_t data_size;
+  size_t bss_size;
+
+  text_size  = rtems_rtl_obj_text_size (obj) + rtems_rtl_obj_const_alignment (obj);
+  const_size = rtems_rtl_obj_const_size (obj) + rtems_rtl_obj_eh_alignment (obj);
+  eh_size    = rtems_rtl_obj_eh_size (obj) + rtems_rtl_obj_data_alignment (obj);
+  data_size  = rtems_rtl_obj_data_size (obj) + rtems_rtl_obj_bss_alignment (obj);
+  bss_size   = rtems_rtl_obj_bss_size (obj);
+
+  /*
+   * Set the sizes held in the object data. We need this for a fast reference.
+   */
+  obj->text_size  = text_size;
+  obj->const_size = const_size;
+  obj->data_size  = data_size;
+  obj->eh_size    = eh_size;
+  obj->bss_size   = bss_size;
+
+  /*
+   * Perform any specific allocations for sections.
+   */
+  if (handler != NULL)
+  {
+    if (!rtems_rtl_obj_section_handler (RTEMS_RTL_OBJ_SECT_TYPES,
+                                        obj,
+                                        fd,
+                                        handler,
+                                        data))
+    {
+      obj->exec_size = 0;
+      return false;
+    }
+  }
+
+  /*
+   * Let the allocator manage the actual allocation. The user can use the
+   * standard heap or provide a specific allocator with memory protection.
+   */
+  if (!rtems_rtl_alloc_module_new (&obj->text_base, text_size,
+                                   &obj->const_base, const_size,
+                                   &obj->eh_base, eh_size,
+                                   &obj->data_base, data_size,
+                                   &obj->bss_base, bss_size))
+  {
+    obj->exec_size = 0;
+    rtems_rtl_set_error (ENOMEM, "no memory to load obj");
+    return false;
+  }
+
+  obj->exec_size = text_size + const_size + eh_size + data_size + bss_size;
+
+  if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
+  {
+    printf ("rtl: load sect: text  - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->text_base, text_size, rtems_rtl_obj_text_alignment (obj));
+    printf ("rtl: load sect: const - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->const_base, const_size, rtems_rtl_obj_const_alignment (obj));
+    printf ("rtl: load sect: eh    - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->eh_base, eh_size, rtems_rtl_obj_eh_alignment (obj));
+    printf ("rtl: load sect: data  - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->data_base, data_size, rtems_rtl_obj_data_alignment (obj));
+    printf ("rtl: load sect: bss   - b:%p s:%zi a:%" PRIu32 "\n",
+            obj->bss_base, bss_size, rtems_rtl_obj_bss_alignment (obj));
+  }
+
+  /*
+   * Determine the load order.
+   */
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_TEXT,  obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_CONST, obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_EH,    obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_DATA,  obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_BSS,   obj);
+
+  /*
+   * Locate all text, data and bss sections in seperate operations so each type of
+   * section is grouped together.
+   */
+  rtems_rtl_obj_sections_locate (RTEMS_RTL_OBJ_SECT_TEXT,
+                                 rtems_rtl_alloc_text_tag (),
+                                 obj, obj->text_base);
+  rtems_rtl_obj_sections_locate (RTEMS_RTL_OBJ_SECT_CONST,
+                                 rtems_rtl_alloc_const_tag (),
+                                 obj, obj->const_base);
+  rtems_rtl_obj_sections_locate (RTEMS_RTL_OBJ_SECT_EH,
+                                 rtems_rtl_alloc_eh_tag (),
+                                 obj, obj->eh_base);
+  rtems_rtl_obj_sections_locate (RTEMS_RTL_OBJ_SECT_DATA,
+                                 rtems_rtl_alloc_data_tag (),
+                                 obj, obj->data_base);
+  rtems_rtl_obj_sections_locate (RTEMS_RTL_OBJ_SECT_BSS,
+                                 rtems_rtl_alloc_bss_tag (),
+                                 obj, obj->bss_base);
+
+  return true;
+}
+
 static bool
 rtems_rtl_obj_sections_loader (uint32_t                   mask,
@@ -1010,5 +1164,4 @@
   rtems_chain_control* sections = &obj->sections;
   rtems_chain_node*    node = rtems_chain_first (sections);
-  size_t               base_offset = 0;
   int                  order = 0;
 
@@ -1026,10 +1179,4 @@
       if (sect->load_order == order)
       {
-        if ((sect->flags & RTEMS_RTL_OBJ_SECT_ARCH_ALLOC) == 0)
-        {
-          base_offset = rtems_rtl_obj_align (base_offset, sect->alignment);
-          sect->base = base + base_offset;
-        }
-
         if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
           printf ("rtl: loading:%2d: %s -> %p (s:%zi f:%04" PRIx32
@@ -1059,7 +1206,4 @@
         }
 
-        if (sect->base)
-          base_offset += sect->size;
-
         ++order;
 
@@ -1073,90 +1217,4 @@
 
   rtems_rtl_alloc_wr_disable (tag, base);
-
-  return true;
-}
-
-bool
-rtems_rtl_obj_alloc_sections (rtems_rtl_obj*             obj,
-                              int                        fd,
-                              rtems_rtl_obj_sect_handler handler,
-                              void*                      data)
-{
-  size_t text_size;
-  size_t const_size;
-  size_t eh_size;
-  size_t data_size;
-  size_t bss_size;
-
-  text_size  = rtems_rtl_obj_text_size (obj) + rtems_rtl_obj_const_alignment (obj);
-  const_size = rtems_rtl_obj_const_size (obj) + rtems_rtl_obj_eh_alignment (obj);
-  eh_size    = rtems_rtl_obj_eh_size (obj) + rtems_rtl_obj_data_alignment (obj);
-  data_size  = rtems_rtl_obj_data_size (obj) + rtems_rtl_obj_bss_alignment (obj);
-  bss_size   = rtems_rtl_obj_bss_size (obj);
-
-  /*
-   * Set the sizes held in the object data. We need this for a fast reference.
-   */
-  obj->text_size  = text_size;
-  obj->const_size = const_size;
-  obj->data_size  = data_size;
-  obj->eh_size    = eh_size;
-  obj->bss_size   = bss_size;
-
-  /*
-   * Perform any specific allocations for sections.
-   */
-  if (handler != NULL)
-  {
-    if (!rtems_rtl_obj_section_handler (RTEMS_RTL_OBJ_SECT_TYPES,
-                                        obj,
-                                        fd,
-                                        handler,
-                                        data))
-    {
-      obj->exec_size = 0;
-      return false;
-    }
-  }
-
-  /*
-   * Let the allocator manage the actual allocation. The user can use the
-   * standard heap or provide a specific allocator with memory protection.
-   */
-  if (!rtems_rtl_alloc_module_new (&obj->text_base, text_size,
-                                   &obj->const_base, const_size,
-                                   &obj->eh_base, eh_size,
-                                   &obj->data_base, data_size,
-                                   &obj->bss_base, bss_size))
-  {
-    obj->exec_size = 0;
-    rtems_rtl_set_error (ENOMEM, "no memory to load obj");
-    return false;
-  }
-
-  obj->exec_size = text_size + const_size + eh_size + data_size + bss_size;
-
-  if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
-  {
-    printf ("rtl: load sect: text  - b:%p s:%zi a:%" PRIu32 "\n",
-            obj->text_base, text_size, rtems_rtl_obj_text_alignment (obj));
-    printf ("rtl: load sect: const - b:%p s:%zi a:%" PRIu32 "\n",
-            obj->const_base, const_size, rtems_rtl_obj_const_alignment (obj));
-    printf ("rtl: load sect: eh    - b:%p s:%zi a:%" PRIu32 "\n",
-            obj->eh_base, eh_size, rtems_rtl_obj_eh_alignment (obj));
-    printf ("rtl: load sect: data  - b:%p s:%zi a:%" PRIu32 "\n",
-            obj->data_base, data_size, rtems_rtl_obj_data_alignment (obj));
-    printf ("rtl: load sect: bss   - b:%p s:%zi a:%" PRIu32 "\n",
-            obj->bss_base, bss_size, rtems_rtl_obj_bss_alignment (obj));
-  }
-
-  /*
-   * Determine the load order.
-   */
-  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_TEXT,  obj);
-  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_CONST, obj);
-  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_EH,    obj);
-  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_DATA,  obj);
-  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_BSS,   obj);
 
   return true;
Index: cpukit/libdl/rtl-shell.c
===================================================================
--- cpukit/libdl/rtl-shell.c	(revision be50969881b97180bf4fc1e2975efd41169e08bb)
+++ cpukit/libdl/rtl-shell.c	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -144,4 +144,5 @@
   bool                 symbols;      /**< Print the global symbols. */
   bool                 dependencies; /**< Print any dependencies. */
+  bool                 trampolines;  /**< Print trampoline stats. */
   bool                 base;         /**< Include the base object file. */
   const char*          re_name;      /**< Name regx to filter on. */
@@ -516,4 +517,6 @@
     rtems_printf (print->printer, "%-*cusers         : %zu\n", indent, ' ', obj->users);
     rtems_printf (print->printer, "%-*creferences    : %zu\n", indent, ' ', obj->refs);
+    rtems_printf (print->printer, "%-*ctrampolines   : %zu\n", indent, ' ',
+                  rtems_rtl_obj_trampolines (obj));
     rtems_printf (print->printer, "%-*csymbols       : %zi\n", indent, ' ', obj->global_syms);
     rtems_printf (print->printer, "%-*csymbol memory : %zi\n", indent, ' ', obj->global_size);
@@ -536,4 +539,31 @@
       rtems_printf (print->printer, "\n");
   }
+  if (print->trampolines)
+  {
+    if (obj->tramp_size == 0)
+    {
+      rtems_printf (print->printer, "%-*ctrampolines: not supported\n", indent, ' ');
+    }
+    else
+    {
+      size_t slots = rtems_rtl_obj_trampoline_slots (obj);
+      size_t used = rtems_rtl_obj_trampolines (obj);
+      rtems_printf (print->printer, "%-*ctrampolines:\n", indent, ' ');
+      rtems_printf (print->printer, "%-*cslots     : %zu\n", indent + 4, ' ',
+                    slots);
+      rtems_printf (print->printer, "%-*csize      : %zu\n", indent + 4, ' ',
+                    obj->tramps_size);
+      rtems_printf (print->printer, "%-*cslot size : %zu\n", indent + 4, ' ',
+                    obj->tramp_size);
+      rtems_printf (print->printer, "%-*cused      : %zu\n", indent + 4, ' ',
+                    used);
+      rtems_printf (print->printer, "%-*crelocs    : %zu\n", indent + 4, ' ',
+                    obj->tramp_relocs);
+      rtems_printf (print->printer, "%-*cunresolved: %zu\n", indent + 4, ' ',
+                    slots - obj->tramp_relocs);
+      rtems_printf (print->printer, "%-*cyield     : %zu%%\n", indent + 4, ' ',
+                    slots ? (used * 100) / slots : 0);
+    }
+  }
   return true;
 }
@@ -568,16 +598,29 @@
 {
   rtems_rtl_obj_print print = { 0 };
-  if (!rtems_rtl_check_opts (printer, "nlmsdb", argc, argv))
+  if (!rtems_rtl_check_opts (printer, "anlmsdbt", argc, argv))
     return 1;
   print.printer = printer;
   print.indent = 1;
   print.oname = true;
-  print.names = rtems_rtl_parse_opt ('n', argc, argv);
-  print.stats = rtems_rtl_parse_opt ('l', argc, argv);;
-  print.memory_map = rtems_rtl_parse_opt ('m', argc, argv);;
-  print.symbols = rtems_rtl_parse_opt ('s', argc, argv);
-  print.dependencies = rtems_rtl_parse_opt ('d', argc, argv);;
-  print.base = rtems_rtl_parse_opt ('b', argc, argv);;
-  print.re_name = rtems_rtl_parse_arg (' ', NULL, argc, argv);
+  if (rtems_rtl_parse_opt ('a', argc, argv))
+  {
+    print.names = true;
+    print.stats = true;
+    print.memory_map = true;
+    print.symbols = true;
+    print.dependencies = true;
+    print.trampolines = true;
+  }
+  else
+  {
+    print.names = rtems_rtl_parse_opt ('n', argc, argv);
+    print.stats = rtems_rtl_parse_opt ('l', argc, argv);;
+    print.memory_map = rtems_rtl_parse_opt ('m', argc, argv);;
+    print.symbols = rtems_rtl_parse_opt ('s', argc, argv);
+    print.dependencies = rtems_rtl_parse_opt ('d', argc, argv);;
+    print.trampolines = rtems_rtl_parse_opt ('t', argc, argv);;
+    print.base = rtems_rtl_parse_opt ('b', argc, argv);;
+    print.re_name = rtems_rtl_parse_arg (' ', NULL, argc, argv);
+  }
   print.re_symbol = NULL;
   print.rtl = rtems_rtl_lock ();
Index: cpukit/libdl/rtl-trampoline.h
===================================================================
--- cpukit/libdl/rtl-trampoline.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
+++ cpukit/libdl/rtl-trampoline.h	(revision b36c52097f52012f9a52dff6fc8393d63805158b)
@@ -0,0 +1,94 @@
+/*
+ *  COPYRIGHT (c) 2019 Chris Johns <chrisj@rtems.org>
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.org/license/LICENSE.
+ */
+/**
+ * @file
+ *
+ * @ingroup rtems_rtl
+ *
+ * @brief RTEMS Run-Time Linker Object File Trampoline Relocations Table.
+ *
+ * Cache relocation records that could result in a trampoline. The unresolved
+ * symbol table holds variable the symbol name (length string) and the object
+ * file's relocation records that reference the unresolved symbol. The
+ * trampoline cache is an extension to this table to reuse the code and memory
+ * and support trampolines.
+ *
+ * Some architectures require trampolines or veneers to extend the range of
+ * some instructions. The compiler generates small optimized instructions
+ * assuming most destinations are within the range of the instruction. The
+ * instructions are smaller in size and can have a number of encodings with
+ * different ranges. If a relocation record points to a symbol that is out of
+ * range for the instruction a trampoline is used to extend the instruction's
+ * range. A trampoline is a small fragment of architecture specific
+ * instructions located within the range of the relocation record instruction
+ * that can reach the entire address range. The trampoline's execution is
+ * transparent to the execution of the object file.
+ *
+ * An object file that needs a trampoline has a table allocated close to the
+ * text section. It has to be close to ensure the largest possible object file
+ * can be spported. The number of slots in a table depends on:
+ *
+ *  # Location of the code
+ *  # The type of relocation records in the object file
+ *  # The instruction encoding the relocation record points too
+ *  # The landing address of the instruction
+ *
+ * The allocation of the text segment and the trampoline table have to happen
+ * with the allocator lock being locked and held to make sure no other
+ * allocations happen inbetween the text section allocation and the trampoline
+ * table. Holding an allocator lock limits what the link editor can do when
+ * when the default heap allocator is being used. If calls any operating
+ * system services including the file system use the same allocator a deadlock
+ * will occur. This creates a conflict between performing the allocations
+ * together and reading the instructions while holding the allocator lock.
+ *
+ * The trampoline cache holds the parsed relocation records that could result
+ * in a trampoline. These records can be exaimined after the allocation of the
+ * text segment to determine how many relocation record target's are out of
+ * range. The minimum range for a specific type of relocation record has to be
+ * used as the instructions cannot be loaded.
+ */
+
+#if !defined (_RTEMS_RTL_TRAMPOLINE_H_)
+#define _RTEMS_RTL_TRAMPOLINE_H_
+
+#include <rtems/rtl/rtl-unresolved.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * Add a relocation to the list of trampolinr relocations.
+ *
+ * @param obj The object table the relocation record is for.
+ * @param flags Format specific flags.
+ * @param sect The target section number the relocation references.
+ * @param symvalue The symbol's value.
+ * @param rel The format specific relocation data.
+ * @retval true The relocation has been added.
+ * @retval false The relocation could not be added.
+ */
+bool rtems_rtl_trampoline_add (rtems_rtl_obj*        obj,
+                               const uint16_t        flags,
+                               const uint16_t        sect,
+                               const rtems_rtl_word  symvalue,
+                               const rtems_rtl_word* rel);
+
+/**
+ * Remove the relocation records for an object file.
+ *
+ * @param obj The object table the symbols are for.
+ */
+void rtems_rtl_trampoline_remove (rtems_rtl_obj* obj);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif
